import configvalues as conf

import getopt
import os
import sys



_OPTIONS = "x:y:"
_LONGOPTIONS = ["dpi=", "skin=", "opaque", "dontsave", "help"]

_USAGE = """
Usage: gdeskcal [-x <x>] [-y <y>] [--skin=<skinname>] [--opaque] [--dontsave]
                [--dpi=<resolution>] [--help]
"""



#
# Displays the usage text and exits.
#
def usage():

    print _USAGE
    sys.exit(1)




#
# Parses the given command line options and adjusts the given configuration.
#
def parse(cmdline, config):

    try:
        opts, nil = getopt.getopt(cmdline, _OPTIONS, _LONGOPTIONS)
    except:
        usage()


    for o, a in opts:
        if (o in ["--skin"]):
            config.set_offset([conf.SKIN])
            config.clear()
            config.load(os.path.join("skins", a, "skin.xml"))
            config.set_offset([])

        elif (o in ["--dpi"]):
            config.set([conf.TEMPORARY, conf.DPI], a)
            
        elif (o in ["--opaque"]):
            config.set([conf.TEMPORARY, conf.TRANSPARENCY], "0")

        elif (o in ["--dontsave"]):
            config.set([conf.TEMPORARY, conf.SAVE_CHANGES], "0")

        elif (o in ["-x"]):
            config.set([conf.GEOMETRY, conf.WINDOW, conf.X], a)
            
        elif (o in ["-y"]):
            config.set([conf.GEOMETRY, conf.WINDOW, conf.Y], a)

        elif (o in ["--help"]):
            usage()

    #end for
